

using System;
using IRaCIS.Core.Domain.Share;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Collections.Generic;

namespace IRaCIS.Core.Domain.Models
{
	///<summary>
	/// 项目阅片标准
	///</summary>
	[Table("ReadingQuestionCriterionTrial")]
	public class ReadingQuestionCriterionTrial : Entity, IAuditAdd
	{
		/// <summary>
		/// 系统标准ID
		/// </summary>
		public Guid? ReadingQuestionCriterionSystemId { get; set; }

		/// <summary>
		/// 项目Id
		/// </summary>
		public Guid TrialId { get; set; }

		/// <summary>
		/// 标准
		/// </summary>
		public string CriterionName { get; set; }

		/// <summary>
		/// 是否启用
		/// </summary>
		public bool IsEnable { get; set; }

		/// <summary>
		/// 排序
		/// </summary>
		public int ShowOrder { get; set; }

		/// <summary>
		/// 是否完成配置
		/// </summary>
		public bool IsCompleteConfig { get; set; }

		/// <summary>
		/// 创建时间
		/// </summary>
		public DateTime CreateTime { get; set; }

		/// <summary>
		/// 创建人
		/// </summary>
		public Guid CreateUserId { get; set; }

		/// <summary>
		/// 是否确认
		/// </summary>
		public bool IsConfirm { get; set; }

		/// <summary>
		/// 表单类型
		/// </summary>

		public FormType FormType { get; set; } = FormType.SinglePage;


		/// <summary>
		/// 修约小数点
		/// </summary>
		public int? DigitPlaces { get; set; } = 2;

		

		/// <summary>
		/// 评估结果
		/// </summary>
		public string EvaluationResult { get; set; } = string.Empty;

		/// <summary>
		/// 评估原因
		/// </summary>
		public string EvaluationReason { get; set; } = "肿瘤学阅片评估原因请依据临床数据填写，在与影像学结果不一致时必填。";


		/// <summary>
		/// 是否显示详情
		/// </summary>
		public bool IsShowDetail { get; set; }

		/// <summary>
		/// 同步时间
		/// </summary>
		public DateTime SynchronizeTime { get; set; }


		/// <summary>
		/// 同步器官时间
		/// </summary>
		public DateTime? SynchronizeOriginalTime { get; set; }

		/// <summary>
		/// 项目
		/// </summary>
		[ForeignKey("TrialId")]
		public Trial Trial { get; set; }

		public List<ReadingQuestionTrial> ReadingQuestionTrialList = new List<ReadingQuestionTrial>();
	}


	



}
